<?php

use App\Enums\LogLevelEnum;
use App\Events\ExceptionOccurred;
use App\Http\Middleware\EnsureOnboardingComplete;
use App\Http\Middleware\RedirectIfOnboardingComplete;
use Illuminate\Foundation\Application;
use Illuminate\Foundation\Configuration\Exceptions;
use Illuminate\Foundation\Configuration\Middleware;

return Application::configure(basePath: dirname(__DIR__))
    ->withRouting(
        web: __DIR__.'/../routes/web.php',
        api: __DIR__.'/../routes/api.php',
        commands: __DIR__.'/../routes/console.php',
        health: '/up',
    )
    ->withMiddleware(function (Middleware $middleware) {
        $middleware->alias([
            'onboarding.complete' => EnsureOnboardingComplete::class,
            'onboarding.incomplete' => RedirectIfOnboardingComplete::class,
        ]);
    })
    ->withExceptions(function (Exceptions $exceptions) {
        $exceptions->reportable(function (Throwable $e) {
            $level = match (true) {
                $e instanceof Error => LogLevelEnum::CRITICAL,
                $e instanceof RuntimeException => LogLevelEnum::ERROR,
                $e instanceof InvalidArgumentException => LogLevelEnum::WARNING,
                default => LogLevelEnum::ERROR,
            };

            ExceptionOccurred::dispatch(
                $e,
                $level,
                $e->getMessage(),
                []
            );
        });
    })->create();
